﻿using System;
using System.Windows;
using System.Windows.Controls;
using Infragistics.DragDrop;
using System.Windows.Media;

namespace TestApp
{
    public partial class TestView : UserControl
    {
        public TestView()
        {
            this.InitializeComponent();
            this.Loaded += new RoutedEventHandler(TestView_Loaded);
        }

        private void TestView_Loaded(object sender, RoutedEventArgs e)
        {
            int itemsCount = 10;

            var ch = new System.Collections.ObjectModel.ObservableCollection<string> { "ChannelA" };

            for (int i = 0; i < itemsCount; i++)
            {
                ListBoxItem item1 = new ListBoxItem { Content = string.Format("Item {0}", i) };

                DragSource ds = new DragSource { DragChannels = ch, IsDraggable = true };
                ds.Drop += new EventHandler<DropEventArgs>(ds_Drop);
                item1.SetValue(DragDropManager.DragSourceProperty, ds);

                this.ListBox1.Items.Add(item1);
            }

            DropTarget dt = new DropTarget
            {
                IsDropTarget = true,
                DropChannels = ch,
                DropTargetMarkerBrush = new SolidColorBrush(Colors.Red)
            };

            DragDropManager.SetDropTarget(this.Grid1, dt);
        }

        void ds_Drop(object sender, DropEventArgs e)
        {
            WrapPanel target = e.DropTarget as WrapPanel;

            if (target != null)
            {
                ListBoxItem source = (ListBoxItem)e.DragSource;

                ListBox parent = (ListBox)source.Parent;
                parent.Items.Remove(source);
                target.Children.Add(new TextBlock { Text = source.Content.ToString() });

                DragSource ds = (DragSource)source.GetValue(DragDropManager.DragSourceProperty);
                ds.Drop -= new EventHandler<DropEventArgs>(ds_Drop);
                source.SetValue(DragDropManager.DragSourceProperty, null);
            }
        }
    }
}
